ProductUpgrade [product.alauda.io/v1alpha1]

Description
ProductUpgrade is the Schema for the productupgrades API
Type
object

Specification

PropertyTypeDescription
apiVersionstring

APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

kindstring

Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

metadataObjectMeta

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

specobject

ProductUpgradeSpec defines the desired state of ProductUpgrade

statusobject

ProductUpgradeStatus defines the observed state of ProductUpgrade

.spec

Description
ProductUpgradeSpec defines the desired state of ProductUpgrade
Type
object
Required
onlineUpgrade
PropertyTypeDescription
onlineUpgradeobject

OnlineUpgrade is the online upgrade configuration

pauseboolean

Pause is a flag to pause the upgrade

targetArchstring

TargetArch is the architecture of the product to upgrade to

targetVersionstring

TargetVersion is the version of the product to upgrade to

typestring

Type is the type of product upgrade

upgradeboolean

Upgrade is a flag of to do the upgrade

.spec.onlineUpgrade

Description
OnlineUpgrade is the online upgrade configuration
Type
object
Required
checkFrequencyenableenableMsgNotify
PropertyTypeDescription
checkFrequencyinteger

CheckFrequency is the frequency to check for new version

enableboolean

Enable is a flag to enable online upgrade

enableMsgNotifyboolean

EnableMsgNotify is a flag to enable message notification

.status

Description
ProductUpgradeStatus defines the observed state of ProductUpgrade
Type
object
Required
phasesourcestatus
PropertyTypeDescription
lastCheckTimestampstring

LastCheckTimestamp is the last time the product upgrade was checked

messagestring

Message is the message of the product upgrade

phasestring

Phase is the phase of the product upgrade

preheatVersionsarray

PreHeatVersions is the pre-heat histories of the product upgrade

sourceobject

OnlineUpgradeSource is the source of online upgrade

statusstring

Status is the status of the product upgrade

upgradableboolean

Upgradable is a flag to indicate whether the product is upgradable

upgradeBlockReasonstring

UpgradeBlockReason is the reason why the product is not upgradable

upgradePathsarray

UpgradePaths is the upgrade paths of the product upgrade

.status.preheatVersions

Description
PreHeatVersions is the pre-heat histories of the product upgrade
Type
array

.status.preheatVersions[]

Description
PreheatHistory defines the pre-heat history
Type
object
Required
archstatusversion
PropertyTypeDescription
archstring

Arch is the architecture of the new version

artifactsAllinteger

ArtifactsAll is the number of artifacts

artifactsSyncedinteger

ArtifactsSynced is the number of artifacts synced

baseOperatorVerstring

BaseOperatorVer is the version of the base operator

preHeatEndTimestring

PreHeatEndTime is the end time of pre-heat

preHeatStartTimestring

PreHeatStartTime is the start time of pre-heat

progressinteger

Progress is the progress of pre-heat

statusstring

PreHeatStatus is the pre-heat status

versionstring

Version is the version of the product to upgrade to

.status.source

Description
OnlineUpgradeSource is the source of online upgrade
Type
object
Required
registry
PropertyTypeDescription
envIdinteger

EnvId is the environment id

insecureboolean

Insecure is a flag to enable insecure registry

plainHttpboolean

PlainHttp is a flag to enable plain http

registrystring

Registry is the cloud registry

tenantIdinteger

TenantId is the tenant id

.status.upgradePaths

Description
UpgradePaths is the upgrade paths of the product upgrade
Type
array

.status.upgradePaths[]

Description
UpgradePath defines the upgrade path
Type
object
Required
archesreleasesizesversion
PropertyTypeDescription
archesarray

Arches is the architectures of the new version

releasestring

Release is the release version of the product to upgrade to

sizesarray

Sizes is the architectures of the new version

tagsarray

Tags is the tags of the new version

versionstring

Version is the version of the product to upgrade to

.status.upgradePaths[].arches

Description
Arches is the architectures of the new version
Type
array

.status.upgradePaths[].arches[]

Type
string

.status.upgradePaths[].sizes

Description
Sizes is the architectures of the new version
Type
array

.status.upgradePaths[].sizes[]

Type
integer

.status.upgradePaths[].tags

Description
Tags is the tags of the new version
Type
array

.status.upgradePaths[].tags[]

Type
string

API Endpoints

The following API endpoints are available:

  • /apis/product.alauda.io/v1alpha1/productupgrades
    • DELETE: delete collection of ProductUpgrade
    • GET: list objects of kind ProductUpgrade
    • POST: create a new ProductUpgrade
  • /apis/product.alauda.io/v1alpha1/productupgrades/{name}
    • DELETE: delete the specified ProductUpgrade
    • GET: read the specified ProductUpgrade
    • PATCH: partially update the specified ProductUpgrade
    • PUT: replace the specified ProductUpgrade
  • /apis/product.alauda.io/v1alpha1/productupgrades/{name}/status
    • GET: read status of the specified ProductUpgrade
    • PATCH: partially update status of the specified ProductUpgrade
    • PUT: replace status of the specified ProductUpgrade

/apis/product.alauda.io/v1alpha1/productupgrades

HTTP method
DELETE
Description
delete collection of ProductUpgrade
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
list objects of kind ProductUpgrade
HTTP responses
HTTP codeResponse body
200 - OKProductUpgradeList schema
401 - UnauthorizedEmpty
HTTP method
POST
Description
create a new ProductUpgrade
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyProductUpgrade schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKProductUpgrade schema
201 - CreatedProductUpgrade schema
202 - AcceptedProductUpgrade schema
401 - UnauthorizedEmpty

/apis/product.alauda.io/v1alpha1/productupgrades/{name}

HTTP method
DELETE
Description
delete the specified ProductUpgrade
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
202 - AcceptedStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
read the specified ProductUpgrade
HTTP responses
HTTP codeResponse body
200 - OKProductUpgrade schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update the specified ProductUpgrade
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKProductUpgrade schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace the specified ProductUpgrade
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyProductUpgrade schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKProductUpgrade schema
201 - CreatedProductUpgrade schema
401 - UnauthorizedEmpty

/apis/product.alauda.io/v1alpha1/productupgrades/{name}/status

HTTP method
GET
Description
read status of the specified ProductUpgrade
HTTP responses
HTTP codeResponse body
200 - OKProductUpgrade schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update status of the specified ProductUpgrade
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKProductUpgrade schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace status of the specified ProductUpgrade
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyProductUpgrade schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKProductUpgrade schema
201 - CreatedProductUpgrade schema
401 - UnauthorizedEmpty